#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <pthread.h>
#include <sched.h>
#include <sys/time.h>
#include <limits.h>
#include <errno.h>

pthread_mutex_t  mutex;       /* mutex object */
int              t_count;      /* thread count */
 
 

typedef struct param
{
//    int id;
    long value;
    int number;
}param;

void fib(void * arg){
     void *status;
     int s;
     param * p = (param *)arg;
     pthread_mutex_lock( &mutex);
     t_count++;
     pthread_mutex_unlock( &mutex);
     if (p->number > 2){
	pthread_t  th1,th2;	
	param p1,p2;
	p1.number=p->number-1;
	p2.number=p->number-2;
	
	s = pthread_create(&th1, NULL, (void *) &fib, (void *) &p1);
   	if (s == EAGAIN ){perror ("pthread_create");}
	s = pthread_create(&th2, NULL, (void *) &fib, (void *) &p2);
   	if (s == EAGAIN ){perror ("pthread_create");}
	pthread_join(th1, &status);
	pthread_join(th2, &status);
	pthread_mutex_lock( &mutex);
	p->value=p1.value+p2.value;	
	pthread_mutex_unlock( &mutex);
     }
     else{
	p->value=1;
   	pthread_exit(NULL);
     }
}

long fibonacci(int n)
{
   void *status;
   int s;   
   pthread_t  th;
   param p;
   p.number=n;
   pthread_mutex_init(&mutex, NULL);   
   s = pthread_create(&th, NULL, (void *) &fib, (void *) &p);
   if (s == EAGAIN ){perror ("pthread_create");}
   pthread_join(th, &status);
   return p.value;

}
int main(int argc,char** argv)
{
  int n,result;
  float  time;
  struct timeval t1, t2;
  if (argc==1){
	printf("Enter a natural number: ");
	if (scanf("%d", &n) != 1) {
		printf("Input error.\n");
		return 1;
	}
  }else if (argc > 2){
	printf("Usage : %s <N>\n",argv[0]);
	return 1;
  }else{
	n = (int)atoi(argv[1]);
  }
  if (n<0) {
    printf("Fibonacci is undefined for negative integers.\n");
    return -1;
  }
  else {
    gettimeofday(&t1, NULL);
    result=fibonacci(n);
    gettimeofday(&t2, NULL);
    time = (t2.tv_sec - t1.tv_sec) + ((float)(t2.tv_usec - t1.tv_usec))/1000000;
    printf("fib(%d)=%d\n",n,result);
    printf("time = %f s\n",time);
    //printf("t_count = %d \n",t_count);
  }
  return 0;
}
